# -*- coding: utf-8 -*- 
# @Time    : 03/22/2024 
# @Author  : nzooherd 
# @File    : message_dao.py 
# @Software: Visual Studio Code

from typing import Optional

from sqlalchemy import select
from dao import BaseDao
from dao.model import Message


class MessageDao(BaseDao):

    model = Message

    @classmethod
    async def update_by_id(cls, message: Message):
        async with cls.session() as session:
            await session.merge(message)

    @classmethod
    async def select_by_telegram_id(cls, telegram_id: int) -> Optional[Message]:
        async with cls.session() as session:
            query = select(cls.model).filter_by(message_id=telegram_id)
            result = await session.execute(query)
            message = result.scalars().first()
            if not message:
                return None
            session.expunge(message)
            return message
